#pragma once

#include "core/module.h"
#include "image_parser.h"

namespace orb
{
    class ORBDecoderModule : public ProcessingModule
    {
    protected:
        std::atomic<size_t> filesize;
        std::atomic<size_t> progress;

        ImageParser l2_parser;
        ImageParser l3_parser;

    public:
        ORBDecoderModule(std::string input_file, std::string output_file_hint, nlohmann::json parameters);
        void process();
        void drawUI(bool window);

    public:
        static std::string getID();
        virtual std::string getIDM() { return getID(); };
        static std::vector<std::string> getParameters();
        static std::shared_ptr<ProcessingModule> getInstance(std::string input_file, std::string output_file_hint, nlohmann::json parameters);
    };
}
